Description

We add several plugins to redmine code base and start running tests. Since some plugins intentionally break vanilla redmine logic a

couple of tests fails. It looks confusing.

To avoid that failures we patched redmine to skip tests if specific plugins are loaded. Unfortunately it does not work for functional

tests, because of this piece of code: test/functional/admin_controller_test.rb:105

  def test_no_plugins

    Redmine::Plugin.clear

    get :plugins

    assert_response :success

    assert_template 'plugins'

  end

 The method Redmine::Plugin.clear looks suspicious: it clears hash of installing plugins without really unloading them. Plugin is

loaded but every other class believes it does not.

It is a defect or behaviour by design?

Associated revisions

Revision 12987 - 2014-03-21 02:06 - Jean-Philippe Lang

Don't clear plugins in tests (#16258).

Revision 12988 - 2014-03-21 02:12 - Jean-Philippe Lang

Don't clear plugins in tests (#16258).

History

#1 - 2014-03-21 02:07 - Jean-Philippe Lang

- Assignee set to Jean-Philippe Lang

This is the expected behaviour, this method is for testing purpose and does not unload plugins indeed.

See the source comments: source:/tags/2.5.0/lib/redmine/plugin.rb#L110

The call to the method in this test is removed in r12987, let me know if it solves your issue.

#2 - 2014-03-21 02:12 - Jean-Philippe Lang

- Status changed from New to Needs feedback

Other calls to Redmine::Plugin.clear are removed from tests in r12988.

#3 - 2014-03-21 10:17 - Kirill  Smirnov

The patches 12987 and 12988 really solve our issue, thank you!

#4 - 2021-07-24 04:00 - Go MAEDA

- Status changed from Needs feedback to Closed

- Resolution set to Fixed
https://www.redmine.org/projects/redmine/repository/svn/entry/tags/2.5.0/lib/redmine/plugin.rb#L110
https://www.redmine.org/projects/redmine/repository/svn/revisions/12987
https://www.redmine.org/projects/redmine/repository/svn/revisions/12988


Kirill  Smirnov wrote:

The patches 12987 and 12988 really solve our issue, thank you!

 Closing this issue.
